// BonTestDlg.cpp : t@C
//

#include "stdafx.h"
#include "BonTest.h"
#include "BonTestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CBonTestDlg _CAO
CBonTestDlg::CBonTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBonTestDlg::IDD, pParent)
	, m_iChannel(0)
	, m_iService(0)
	, m_iSpace(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	
	// INIL[o^
	m_csRecordPath.RegisterKey(CONFSECT_GENERAL, TEXT("RecordPath"), TEXT("C:\\BonTest.ts"));
}

void CBonTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBonSampleDlg)
	DDX_CBIndex(pDX, IDC_CHCOMBO, m_iChannel);
	DDX_CBIndex(pDX, IDC_SVCOMBO, m_iService);
	DDX_CBIndex(pDX, IDC_SPCOMBO, m_iSpace);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBonTestDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_RESET, &CBonTestDlg::OnBnClickedReset)
	ON_CBN_SELCHANGE(IDC_SPCOMBO, &CBonTestDlg::OnSelChangeSpace)
	ON_CBN_SELCHANGE(IDC_CHCOMBO, &CBonTestDlg::OnSelChangeChannel)
	ON_CBN_SELCHANGE(IDC_SVCOMBO, &CBonTestDlg::OnSelChangeService)
	ON_BN_CLICKED(IDC_STARTRECORD, &CBonTestDlg::OnBnClickedStartRecord)
	ON_BN_CLICKED(IDC_STOPRECORD, &CBonTestDlg::OnBnClickedStopRecord)
	ON_BN_CLICKED(IDC_BROWSEPATH, &CBonTestDlg::OnBnClickedBrowsePath)
	ON_BN_CLICKED(IDC_OPENFILE, &CBonTestDlg::OnBnClickedOpenFile)
	ON_BN_CLICKED(IDC_PLAY, &CBonTestDlg::OnBnClickedPlay)
	ON_BN_CLICKED(IDC_PAUSE, &CBonTestDlg::OnBnClickedPause)
END_MESSAGE_MAP()


// CBonTestDlg bZ[W nh

BOOL CBonTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[VXe j[ɒǉ܂B

	// IDM_ABOUTBOX ́AVXe R}h͈͓̔ɂȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
//	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B

	// ݒ蕜
	SetDlgItemText(IDC_RECORDPATH, m_csRecordPath);

	// DTVGWI[v
	if(m_DtvEngine.OpenEngine(this, GetDlgItem(IDC_VIEW)->GetSafeHwnd())){
		// vr[Jn
		m_DtvEngine.EnablePreview();
		}

	// `lXV
	CComboBox *pSpaceCombo = static_cast<CComboBox *>(GetDlgItem(IDC_SPCOMBO));
	CComboBox *pChannelCombo = static_cast<CComboBox *>(GetDlgItem(IDC_CHCOMBO));

	if(m_DtvEngine.m_BonSrcDecoder.IsBonDriver2()){
		pSpaceCombo->ResetContent();
		pChannelCombo->ResetContent();

		// `[jOԖXV
		for(DWORD dwSpace = 0UL ; m_DtvEngine.m_BonSrcDecoder.GetSpaceName(dwSpace) ; dwSpace++){
			pSpaceCombo->AddString(m_DtvEngine.m_BonSrcDecoder.GetSpaceName(dwSpace));
			}

		// `lXV
		for(DWORD dwChannel = 0UL ; m_DtvEngine.m_BonSrcDecoder.GetChannelName(0UL, dwChannel) ; dwChannel++){
			pChannelCombo->AddString(m_DtvEngine.m_BonSrcDecoder.GetChannelName(0UL, dwChannel));
			}
		}
	
	pSpaceCombo->SetCurSel(0);	
	pChannelCombo->SetCurSel(0);	

	UpdateData(FALSE);
	SetTimer(1, 500UL, NULL);

	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

void CBonTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CBonTestDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CBonTestDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CBonTestDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: ɃbZ[W nh R[hǉ܂B

	KillTimer(1);
	
	// DTVGWN[Y
	m_DtvEngine.CloseEngine();
}

void CBonTestDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	
	// Mx擾
	CString csText, csTemp;
	csText.Format(TEXT("MxF@%.2fdB"), m_DtvEngine.m_BonSrcDecoder.GetSignalLevel());
	SetDlgItemText(IDC_STATUS, csText);

	if(GetDlgItem(IDC_VIEW)->GetWindow(GW_CHILD)){
		GetDlgItem(IDC_VIEW)->GetWindow(GW_CHILD)->InvalidateRect(NULL);
		}

	// Xe[^Xo[XV
	csText = TEXT("");
	
	csTemp.Format(TEXT("́F %lu    "), m_DtvEngine.m_TsPacketParser.GetInputPacketCount());
	csText += csTemp;

	csTemp.Format(TEXT("óF %lu    "), m_DtvEngine.m_TsPacketParser.GetOutputPacketCount());
	csText += csTemp;

	csTemp.Format(TEXT("G[F %lu    "), m_DtvEngine.m_TsPacketParser.GetErrorPacketCount());
	csText += csTemp;

	csTemp.Format(TEXT("RF %lu    "), m_DtvEngine.m_TsDescrambler.GetScramblePacketCount());
	csText += csTemp;

	csTemp.Format(TEXT("^TCYF %.2lfMB"), (double)m_DtvEngine.m_FileWriter.GetWriteSize() / (1024.0 * 1024.0));
	csText += csTemp;

	SetDlgItemText(IDC_INFOBAR, csText);

	CDialog::OnTimer(nIDEvent);
}

void CBonTestDlg::OnBnClickedReset()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	m_DtvEngine.ResetEngine();
}

void CBonTestDlg::OnSelChangeSpace()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	UpdateData(TRUE);

	// `lXV
	if(m_DtvEngine.m_BonSrcDecoder.IsBonDriver2()){
		CComboBox *pChannelCombo = static_cast<CComboBox *>(GetDlgItem(IDC_CHCOMBO));
		pChannelCombo->ResetContent();

		// `lXV
		for(DWORD dwChannel = 0UL ; m_DtvEngine.m_BonSrcDecoder.GetChannelName((DWORD)m_iSpace, dwChannel) ; dwChannel++){
			pChannelCombo->AddString(m_DtvEngine.m_BonSrcDecoder.GetChannelName((DWORD)m_iSpace, dwChannel));
			}

		pChannelCombo->SetCurSel(0);	

		if(!m_DtvEngine.SetChannel((BYTE)m_iSpace, 0U)){
			::AfxMessageBox(TEXT("`l̐ؑւɎs܂B"));
			}
		}
}

void CBonTestDlg::OnSelChangeChannel()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	UpdateData(TRUE);

	if(!m_DtvEngine.SetChannel((BYTE)m_iSpace, (WORD)m_iChannel)){
		::AfxMessageBox(TEXT("`l̐ؑւɎs܂B"));
		}
		
	CComboBox *pServiceCombo = static_cast<CComboBox *>(GetDlgItem(IDC_SVCOMBO));
	pServiceCombo->ResetContent();
	pServiceCombo->AddString(TEXT("`lύX..."));
	pServiceCombo->SetCurSel(0);
}

void CBonTestDlg::OnSelChangeService()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	UpdateData(TRUE);

	if(!m_DtvEngine.SetService(m_iService)){
		::AfxMessageBox(TEXT("T[rX̐ؑւɎs܂B"));
		}
}

const DWORD CBonTestDlg::OnDtvEngineEvent(CDtvEngine *pEngine, const DWORD dwEventID, PVOID pParam)
{
	// SɎb
	CProgManager *pProgManager = static_cast<CProgManager *>(pParam);
	CComboBox *pServiceCombo = static_cast<CComboBox *>(GetDlgItem(IDC_SVCOMBO));
	
	pServiceCombo->ResetContent();
	TCHAR szServiceName[1024];
	
	// T[rXXV
	for(WORD wIndex = 0U ; wIndex < pProgManager->GetServiceNum() ; wIndex++){
		if(pProgManager->GetServiceName(szServiceName, wIndex)){
			pServiceCombo->AddString(szServiceName);		
			}
		else{
			pServiceCombo->AddString(TEXT("T[rX擾..."));
			}
		}	

	pServiceCombo->SetCurSel(pEngine->GetService());

	return 0UL;
}

void CBonTestDlg::OnBnClickedStartRecord()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	
	// t@C݊Jn
	if(!m_DtvEngine.m_FileWriter.OpenFile(m_csRecordPath)){
		::AfxMessageBox(TEXT("t@C̃I[vɎs܂B"));
		return;		
		}
		
	// Rg[ԕύX
	GetDlgItem(IDC_STARTRECORD)->EnableWindow(FALSE);
	GetDlgItem(IDC_STOPRECORD)->EnableWindow(TRUE);
}

void CBonTestDlg::OnBnClickedStopRecord()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	
	// t@CݏI
	m_DtvEngine.m_FileWriter.CloseFile();
	
	// Rg[ԕύX
	GetDlgItem(IDC_STARTRECORD)->EnableWindow(TRUE);
	GetDlgItem(IDC_STOPRECORD)->EnableWindow(FALSE);
}

void CBonTestDlg::OnBnClickedBrowsePath()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	
	// t@CI
	CFileDialog Dlg(FALSE, TEXT("ts"), m_csRecordPath, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, TEXT("MPEG2-TS (*.ts)|*.ts||"));
	if(Dlg.DoModal() != IDOK)return;
	
	// Rg[XV
	m_csRecordPath = Dlg.GetPathName();
	SetDlgItemText(IDC_RECORDPATH, m_csRecordPath);
}

void CBonTestDlg::OnBnClickedOpenFile()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	CFileDialog Dlg(TRUE, TEXT("ts"), NULL, OFN_HIDEREADONLY | OFN_FILEMUSTEXIST, TEXT("TSt@C (*.ts)|*.ts||"));
	if(Dlg.DoModal() != IDOK)return;

	if(!m_DtvEngine.PlayFile(Dlg.GetPathName())){
		::AfxMessageBox(TEXT("t@C̃I[vɎs܂B"));
		}
}

void CBonTestDlg::OnBnClickedPlay()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	
}

void CBonTestDlg::OnBnClickedPause()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	m_DtvEngine.StopFile();
}
